﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using Infragistics.Olap.FlatData;
using Infragistics.Olap.Xmla;

namespace HyperlinkHeadersPivot
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);

        }


        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            this.LoadPivotGridWithSampleData();

        }


        List<PartnerPercentage> myList;

        private void LoadPivotGridWithSampleData()
        {
            try
            {


                myList = new List<PartnerPercentage>();
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00041", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00042", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00043", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00047", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00055", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00060", Percentage = 0.1188 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00064", Percentage = 0.0173 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00071", Percentage = 0.0043 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00081", Percentage = 0.0389 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00091", Percentage = 0.0432 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00120", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00126", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00145", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00162 ", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00183", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00208", Percentage = 0.0015 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00209", Percentage = 0.0093 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00242", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00243", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00250", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00256", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00260", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00292", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00301", Percentage = 0.0065 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00326", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00329", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00333", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00335", Percentage = 0.0864 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00340", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00370", Percentage = 0.0324 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00385 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00400", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00875", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment1", Partner = "P00028", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00041", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00042", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00043", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00047", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00055", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00060", Percentage = 0.1188 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00064", Percentage = 0.0173 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00071", Percentage = 0.0043 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00081", Percentage = 0.0389 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00091", Percentage = 0.0432 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00120", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00126", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00145", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00162", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00183", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00208 ", Percentage = 0.0015 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00209", Percentage = 0.0093 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00242 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00243 ", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00250", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00256 ", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00260 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00292", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00301 ", Percentage = 0.0065 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00326", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00329", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00333", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00335", Percentage = 0.0864 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2)", Partner = "P00340", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00370", Percentage = 0.0324 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00385", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00400 ", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00875", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 2", Partner = "P00028", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00041", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00042", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00043", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00047", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00055 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00060", Percentage = 0.1188 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00064", Percentage = 0.0173 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00071", Percentage = 0.0043 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00081 ", Percentage = 0.0389 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00091", Percentage = 0.0432 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00120 ", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00126", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00145", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00162", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00183", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00208", Percentage = 0.0015 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00209", Percentage = 0.0093 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00242", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00243", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00250", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00256 ", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00260", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00292", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00301", Percentage = 0.0065 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00326", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00329 ", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00333", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00335", Percentage = 0.0864 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00340", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00370", Percentage = 0.0324 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00385 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00400", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00875", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 3", Partner = "P00028", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00041", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00042", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00043", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00047", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00055 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00060", Percentage = 0.1188 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00064 ", Percentage = 0.0173 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00071", Percentage = 0.0043 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00081", Percentage = 0.0389 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00091 ", Percentage = 0.0432 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00120", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00126 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00145", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00162", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00183 ", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00208", Percentage = 0.0015 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00209", Percentage = 0.0093 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00242 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00243", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00250 ", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00256 ", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00260", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00292", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00301 ", Percentage = 0.0065 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00326 ", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00329 ", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00333 ", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00335", Percentage = 0.0864 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00340", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00370", Percentage = 0.0324 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00385", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00400", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00875", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 4", Partner = "P00028", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00041", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00042", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00043", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00047", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00055", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00060", Percentage = 0.1188 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00064", Percentage = 0.0173 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00071", Percentage = 0.0043 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00081", Percentage = 0.0389 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00091", Percentage = 0.0432 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00120", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00126", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00145", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00162", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00183 ", Percentage = 0.0022 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00208 ", Percentage = 0.0015 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00209", Percentage = 0.0093 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00242", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00243", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00250", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00256", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00260 ", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00292", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00301 ", Percentage = 0.0065 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00326 ", Percentage = 0.1080 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00329", Percentage = 0.0540 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00333", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00335", Percentage = 0.0864 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00340", Percentage = 0.0216 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00370", Percentage = 0.0324 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00385", Percentage = 0.0108 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00400", Percentage = 0.0000 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00875", Percentage = 0.0054 });
                myList.Add(new PartnerPercentage { Investment = "Investment 5", Partner = "P00028", Percentage = 0.0054 });

                FlatDataSource flatDataSource = new FlatDataSource
                {
                    ItemsSource = myList,
                    Cube = XmlaDataSource.GenerateInitialCube("PartnerPercentage"),
                    Rows = XmlaDataSource.GenerateInitialItems("[Partner].[Partner]"),
                    Columns = XmlaDataSource.GenerateInitialItems("[Investment].[Investment]"),
                    // Columns = XmlaDataSource.GenerateInitialItems("[Investment]{[Investment].&amp[Yangtze Special Situations Fund]}"),
                    Measures = XmlaDataSource.GenerateInitialItems("Percentage"),



                };

                CubeMetadata cubeMetadata = new CubeMetadata();
                cubeMetadata.DisplayName = "Partner Percentage Matrix";
                cubeMetadata.DataTypeFullName = typeof(PartnerPercentage).FullName;
                cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
                {
                    SourcePropertyName = "Percentage",
                    DisplayName = "Percentage",
                    DisplayFormat = "{0:P4}"
                });
                //cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
                //{
                //    SourcePropertyName = "Investment",
                //    DisplayName = "Investment"
                //});
                cubeMetadata.DimensionSettings.Add(new DimensionMetadata()
                {
                    SourcePropertyName = "Partner",
                    DisplayName = "Partner"
                });

                flatDataSource.CubesSettings.Add(cubeMetadata);

                // Define hierarchies
                HierarchyDescriptor<PartnerPercentage> partnerHierarchy = new HierarchyDescriptor<PartnerPercentage>(p => p.Partner);
                partnerHierarchy.AddLevel(p =>
                    "All partners",
                    "All partners"
                    );
                partnerHierarchy.AddLevel(p =>
                    p.Partner,
                    "Partner name"
                    );
                flatDataSource.AddHierarchyDescriptor(partnerHierarchy);

                HierarchyDescriptor<PartnerPercentage> investmentHierarchy = new HierarchyDescriptor<PartnerPercentage>(p => p.Investment);
                investmentHierarchy.AddLevel(p =>
                    "All investments",
                    "All investments"
                    );
                investmentHierarchy.AddLevel(p =>
                    p.Investment,
                    "Investment name"
                    );
                flatDataSource.AddHierarchyDescriptor(investmentHierarchy);

                this.pivotGrid.DataSource = flatDataSource;
                this.dataSelector.DataSource = flatDataSource;



            }
            catch (Exception ex)
            {
                MessageBox.Show("LoadPivotGridWithSampleData - " + ex.Message);
            }
        }



        //holds all rows which are currently selected
        ObservableCollection<PivotDataRow> sel = new ObservableCollection<PivotDataRow>();

        //holds the current row with the last clicked checkbox
        PivotDataRow currentRow;


        private void CheckBox_Click(object sender, RoutedEventArgs e)
        {
            string currName = (sender as CheckBox).Tag.ToString();
            foreach (PivotDataRow pdr in pivotGrid.DataRows)
                if (pdr.HeaderText == currName)
                    currentRow = pdr;

            if ((sender as CheckBox).IsChecked == true)
            {

                sel.Add(currentRow);
            }
            if ((sender as CheckBox).IsChecked == false)
            {

                sel.Remove(currentRow);
            }
        }



    }
}
